
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>一种灵活的电商数据架构 / iVAN</title>

    <meta name="description" content="一种灵活的电商数据架构 一般来说,电商数据架构是比较复杂的,做过电商的同学都有深刻的体会. 具体复杂在什么地方呢,举几个具体的例子: 1.每种商品都有自己的独特属性.比如鞋子和电脑的属性是完全不一样的.如何对他们构造商品数据架构? 2.如何维护它们.不至于因为业务的发展,使得数据结构变得异常复杂而无法拓展和维护? 3.未来可能会卖更多种类的商品.我们人类也会发明出来更多新的商品.如何适应变化? 4.每秒钟的并发量十分巨大,数据架构在这方面如何考量? 5.商品数据配置错误,如果快速就地回滚,为线上快速止血? 6.如何为整">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">一种灵活的电商数据架构</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>一般来说，电商数据架构是比较复杂的，做过电商的同学都有深刻的体会。</p>
<p>具体复杂在什么地方呢，举几个具体的例子：
<ul>
<li>1.每种商品都有自己的独特属性。比如鞋子和电脑的属性是完全不一样的。如何对他们构造商品数据架构？</li>
<li>2.如何维护它们。不至于因为业务的发展，使得数据结构变得异常复杂而无法拓展和维护？</li>
<li>3.未来可能会卖更多种类的商品、我们人类也会发明出来更多新的商品。如何适应变化？</li>
<li>4.每秒钟的并发量十分巨大，数据架构在这方面如何考量？</li>
<li>5.商品数据配置错误，如果快速就地回滚，为线上快速止血？</li>
<li>6.如何为整个开发周期提供支持？</li>
<li>7.其它原因 。</li>
</ul>
<p>在电商这样的场景下，某些问题就变得异常复杂了！</p>
<p>如果我们还是按照传统方式来设计数据架构，比如说和领域模型强绑定的ER方式来设计数据架构，必然会导致数据架构随着业务的发展而变得越来越复杂！<br />
 <br />
所以需要一种新型的数据架构来解决我们系统的基础性问题。</p>
<p>这里提供一种新的思路，也在实际生产环境中验证过了。各位看官和我一起看过来：</p>
<ul>
<li>1.建立统一的、可管理的数据平台，防止数字孤岛的产生，提高数据共享程度并兼顾性能的监管和提升。</li>
<li>2.我们为数据架构提供机制而并不提供策略。将策略放到App端来决定，由App来决定其领域的上层数据架构，不管什么样的电商APP都可以从数据平台“长出来”，模式自由化，做到Code First！</li>
<li>3.提供数据沙箱和多版本回溯的能力，能够快速建立数据clone和止血。</li>
<li>4.提供电商基础数据架构的抽象。</li>
</ul>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL29zcy1jbi1oYW5nemhvdS5hbGl5dW5jcy5jb20veXFmaWxlcy81MTdlZDNiMTM1NDk5MTViMjRmZTZhM2E5ODk3ZmNhNTNiYWJjMDZkLmpwZWc=.jpg"><br />
基于上面的考虑，我们有这样的具体设计和实现：</p>
<p>不同流程、不同节点所绑定的数据模式是不一样的。</p>
<p>比如不同类型客户（普通客户、客户经理等等）对于平台而言对业务的处理流程不同，会形成不同类型的订单，不同类型的订单会产生不同的结算数据模式。</p>
<p>所以模式动态化是一个非常重要的设计轨迹，不然数据模式必然非常复杂，难以拓展和维护，表的数量越多，也会带来性能问题。</p>
<p>互联网系统无非是：  <b>App = 功能编排 + 流程编排 + 业务规则 + 数据编排</b></p>
<p>所以基本设计思路是：<b>动静分离</b></p>
<p><b><br /></b></p>
<p><b>静的部分</b><br />
是系统元数据部分，它们提供了流程编排、功能编排、业务规则以及动态表元数据管理等功能。<br /><b>动的部分</b><br />
动的部分，就是动态表的部分，表示最终的业务数据，并且业务数据可以整体加密了(因为他们是JSON)，数据访问的方式都采用数据中间件的方式（比如Mycat）。实现方式是：
<ul>
<li>1.表空间就是一个MySQL 5.7 + 物理表。表的字段统一都是：</li>
<li>Id | header | payload | creator | createTime</li>
<li>2.我们定义个管理表空间的物理表（元数据表，属于静态部分），一旦有人在此表注册一个表空间，那么就自动根据1中的模式生成一个物理表</li>
<li>3.我们定义一个管理动态表模式的物理表（元数据表，属于静态部分），它使用JSON字符串保存描述动态表结构的json-schema。假设如此：</li>
</ul>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL29zcy1jbi1oYW5nemhvdS5hbGl5dW5jcy5jb20veXFmaWxlcy8zOWE0OTNmYzJmMTE0MGE2MDU4NjMzMjNmYWVkOWNmZjNjOWMyZDZmLmpwZWc=.jpg"></p>
<p>并根据此模式动态生成虚拟列（这是mysql 5.7+本身的能力，具体的请查询官网资料MysqL Json functions）</p>
<ul>
<li>4.我们在写入数据到新建的表空间的时候，根据某个json-schema描述的结构来写入header和data字段，并且使用jsonschema-validator验证格式是否正确。形式如下：
<pre><code>header: { “table”:”a”,
                 ”sandbox”:”test”,
                 ”version”:”时间戳”,
                  snapshot=”标记名字”,
                 ”schemaname”:”aschema” }

payload:{ “id”:”1”,
                 ”name”:”leo”,
                 ”price”:78.89 }   //业务数据</code></pre>
</li>
</ul>
<ul>
<li>5.<br />
此时上层查询类似于：dataContext.select().from(“a”).where(“id=1”);(推荐采用Jinq和JooQ的方<br />
式)虚拟表名在datacontext中可以根据元数据反向找到对应的所有表空间，然后动态形成   union all<br />
SQL并提交MySQL服务器执行。</li>
</ul>
<ul>
<li>6.底层解释为：select id, name, price from 名空间名称 where table=”a” and id=1,union all 其他表空间 where table=”a”…….</li>
</ul>
<p><b>我们约定：</b><br />
    1)  一个虚拟表A可以保存在N个表空间中<br />
    2)  一个表空间可以保存N个虚拟表<br />
    3)  底层DataContext为上层提供透明性，只需要提供虚拟表名、需要提取的列名以及条件即可获取数据，并不会感觉到差异。</p>
<p>虚拟表和表空间的关系由静态元数据表来维护。<br />
   <br />
这样做的目的，是一个虚拟表可以分布在不同表空间甚至是不同库的表空间中，将数据散列，一遍形成分布式表，达到较好的性能要求。</p>
<p>另外上层程序代码通过数据中间件访问数据源，自动分表，进一步提高了性能指标。</p>
<p>7.实际上形成了一个虚拟表体制。<br />
8.我们称payload中json的Id为虚拟表Id，这一点不要和表空间（物理表）的Id向混淆。<br />
9.我们在header中记录版本，如果有N个id=1的虚拟表记录的话，那么我们在上层DataAPI将会看到的数据是版本最大的那一个（这个过程叫做版本塌陷）。<br />
10.如果我们需要回滚数据，只需要指定一个版本并query这个版本的数据并插入虚拟表即可，所有数据形成的历史将会保存起来。<br />
11.在一个表空间（物理表）中，可以存在很多不同schema的虚拟表。<br />
这样我们就具备了一个解放模式的动态表架构，不过要注意：<br />
    1) 由于Mycat的存在，表空间的数据量不会对性能产生不好的影响。<br />
    2) DataAPI应该可以构建并提交静态表和动态虚拟表的联合查询（Mysql支持的）<br />
    3) 迫使我们必须将底层数据架构DataAPI化，这样就做到上层代码会认为静态表和动态表并无差别，做到底层数据架构透明化。<br />
    4) 提供管理API，可以维护元数据的方式动态构成动态表。</p>
<p>12如何实现动态表记录的修改、删除：</p>
<p>    1). 修改：对物理表data字段进行修改，<br />
使用：添加一条新的包含修改好的数据记录，并在header中写入op=modify。来实现更新业务数据。</p>
<p>    2). 删除：按虚拟Id添加一个header中op为del值的空白记录<br />
如：</p>
<pre><code>header: { “table”:”a”,
                  ”changeset”:”test”,
                  ”version”:”时间戳”,
                   snapshot=”标记名字”,
                  ”schemaname”:”aschema”,
                  ”id”:”1” }</code></pre>
<p><pre><code>payload:NULL   // 业务数据。</code></pre>
<p>NULL是个特殊的值，表示已删除。</p>
<p>此时查询时判断payload =NULL and id=1,这条记录就没有了,查询结果为null。<br />
13.sandbox：修改集是一种沙箱概念。</p>
<p>我们约定如果sandbox =test，那么这里的数据就是给beta测试用的。</p>
<p>如果是release就是给正式环境用的。</p>
<p>于是我们预设这样的sandbox名字：<br />
    A:dev 开发用数据<br />
    B:test 测试用数据<br />
    C:release 正式用数据</p>
<p>我们可以这样认为对数据进行了虚拟分区。</p>
<p>一个重要的副产品就是，如果我们需要作一个将会用于正式环境的test数据集，测试之后，我们只需要需要changset为release，那么数据集立即生效，正式环境就可以用了。<br />
 <br />
静态表部分，还设计了工作流部分、业务元数据部分、标签系统部分、权限管理的数据模型，这些模型是稳定的，并且是属于元数据的，动态部分是不同app所形成的模型。</p>
<p><b>至此，我们用有限的底层数据模型手段就可以对应千变万化的业务数据架构了。</b><br /><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL29zcy1jbi1oYW5nemhvdS5hbGl5dW5jcy5jb20veXFmaWxlcy9lNzJjYWNkZjUwMTU1NTI4NDMyYjk1ZjFhMGViMTUzZDZmOTNkM2JkLmpwZWc=.jpg">
<ol>
<li>应用管理静态表: App为前缀的表，  负责应用产品通道的管理</li>
<li>工作流相关静态表: Workflow为前缀的表，负责定义和管理工作流实例</li>
<li>工作流Form静态表: WorkflowForm为前缀的表，定义工作流节点相关的表单以及规则绑定</li>
<li>非工作流Form静态表: NormalForm为前缀的表，定义非工作流绑定的，普通的表单</li>
<li>业务数据元数据静态表: 为业务提供度量衡、城市、地铁等等元数据支持</li>
<li>表空间管理静态表: 用来注册表空间，并由DataAPI服务器创建具体的物理表</li>
<li>动态表模式管理静态表: 动态表注册到表空间，schema注册，并由DataAPI创建动态表</li>
<li>权限管理相关静态表: 应用权限的定义和分配</li>
<li>标签静态表: 用于管理定义标点和打标的表</li>
</ol>
<p><b>预设动态表说明：预设的动态表对应的json-schema不可以被删除和修改，作为root业务基础存在！</b></p>
<p>之后后续的版本都是基于这个root演变出来的。</p>
<p>每个表空间中的表，全部是根据业务形态定义的，定义权利交给了App，也就是通过App代码定义动态表，做到Code First。</p>
<p>并且一个动态表可以有N个注册在表空间中的多个模式，模式也具备版本。</p>
<p>也就是说虚拟表的列定义是可以动态拓展的，并且同时只有一个最新的会生效,可以有回滚模式。</p>
<p>我们约定：动态表的定义就等同于其JSON-schema的定义，也就是说一个动态表对应一个固定的JSON-schema.
<ol>
<li>交易主体表空间</li>
<li>计算规则定义表空间</li>
<li>购物车表空间</li>
<li>订单表空间</li>
<li>财务表空间</li>
<li>商品表空间</li>
</ol>
<p><b>总之，灵活的底层数据架构，决定了基础数据API服务变成了一种基础设施，使得其他业务APP可以在上面方便的拓展和生长。</b></p>
<hr>
<br />                                                        中生代技术群微信公众号</p>
<p>                                                <img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL29zcy1jbi1oYW5nemhvdS5hbGl5dW5jcy5jb20veXFmaWxlcy9kYTkzMTI1MjQ5MjFlNjM3YjY4NGVlZDdiZjMyNDlkYjU4ZjdiYWRjLmpwZWc=.jpg"></p>
<p>本文作者 高磊</p>
<p><b>中生代技术微信号公众号：freshmanTechnology</b> <em><br /></em></p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-04 20:40:44</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong>         </div> -->
	</section>
	
	

		<div id="similar">

		<h3>一种灵活的电商数据架构的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/Mydg5Zb.html" rel="bookmark">如何打造一个小而精的电商网站架构？</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文大纲: 1. 小型电商网站的架构 2. 日志与监控系统的解决方案 3. 构建数据库的主从架构 4. 基于共享存储的图片服务器架构 5. 移动M站建设 6. 系统容量预估 7. 缓存系统      一.小型电商网站的架构     刚从传统软件行业进入到电商企业时,觉得电商网站没有什么技术含量,也没有什么门槛,都是一些现有的东西堆积木似的堆出来罢了.然而,真正进入到这个行业之后,才发现并非如此.有人说过,好的架构,是演化出来的,电商网站的架构也是如此.现在好的电商网站,看似很复杂,很牛逼,其实也			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zJ2me6z.html" rel="bookmark">电商总结（八）如何打造一个小而精的电商网站架构</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				前面写过一些电商网站相关的文章,这几天有时间,就把之前写得网站架构相关的文章,总结整理一下.把以前的一些内容就连贯起来,这样也能系统的知道,一个最小的电商平台是怎么一步步搭建起来的.对以前的文章感兴趣的朋友可以看这个,http://www.cnblogs.com/zhangweizhong/category/879056.html   本文大纲: 1. 小型电商网站的架构 2. 日志与监控系统的解决方案 3. 构建数据库的主从架构 4. 基于共享存储的图片服务器架构 5. 移动M站建设 6. 系			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/p5ND4nz.html" rel="bookmark">电商基础架构建设之路</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在2016年的最后一天,奉上本年度最后一篇文章,也是为自己在当当的工作画上句号. 本人已经离开当当(可称为猴厂),加入饿了么(人称饿厂),负责北京研发中心.以前是输送精神食粮,现在是物质食粮,都是为人民服务,而且人可以不读书,但是不能不吃饭,所以跟生活更息息相关. 在此感谢多年来给我帮助和支持的当当领导和同事,在当当的这几年,经历了很多,结识了很多好朋友,也收获了许多成长,相信当当会越来越好,架构部做出更多的成绩,引领当当技术体系更进一步,小伙伴们事业蒸蒸日上. 今天分享的内容是&quot;电商基础架构建			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MRY7Adb.html" rel="bookmark">AdMaster发布国内首创电商数据监测解决平台，拥抱电商迎接变革</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				(8月21日,上海)中国领先的独立第三方数字营销大数据提供商AdMaster(精硕科技)在北京.上海发布国内首创的电商数据监测解决平台RetailMaster,并以&quot;拥抱电商 迎接变革&quot;主题研讨会的形式分享了大数据时代品牌电子商务可持续增长的数字化解决方案.会议上,AdMaster介绍了国内首个利用三方数据打通来诠释互联网媒体引流到电商购物成单转化过程,来帮助品牌寻找更好的互联网电子营销综合解决方案. 海尔集团品牌运营总监王梅艳.&quot;一号店&quot;副总裁郭冬东.AdMast			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zG0162b.html" rel="bookmark">电商数据造假探密：口径标准不一 退货交易额未剔除</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				20亿元,59亿元,2012年目标300亿元.这是苏宁易购3年来的增长数据. 102亿元,309亿元,2012年目标1000亿元.这是京东商城3年来的增长数据. 4000亿元,6500亿元,2012年目标10000亿元.这是淘宝系3年来的增长数据. 数据脱口而出,难免让人怀疑,放到线下的http://www.aliyun.com/zixun/aggregation/7858.html&quot;&gt;传统零售业,无论如何,在这样的量级是不可能有这么快的增长速度的. 即使参考同类型的全球最大的B2C电子商			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MWGnyqM.html" rel="bookmark">一种面向云计算业务的SDN架构</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一种面向云计算业务的SDN架构 张睿汭 汪洋 随着迁移到云的应用及业务数量和种类的快速增长,联网能力越来越重要.由云服务提供商和云控制器平台提供的联网支持发展迅速.然而,在大多数云联网服务模型中,用户必须配置各种网络层的构造(如交换机.子网和访问控制列表)以供云应用使用.本文提出一种服务级网络模型,该模型能够提供云应用所需要的更高级的连通性和策略抽象. 来源:2013年中国通信学会信息通信网络技术委员会年会论文集 一种面向云计算业务的SDN架构			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MWNAoEb.html" rel="bookmark">电商数据造假、买排名被指成业内普遍现象</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				数据造假成电商普遍现象,专家表示杜绝要靠企业自律. 造数据买排名电商数据信唔过? &quot;今天你网购了吗?&quot;不知不觉间进入了如火如荼的电子商务时代,尿片.奶粉,甚至下一餐的饭,都恨不得用手指的点击来搞掂.然而近日,京东等电商被卷入&quot;数据造假&quot;风波,使得本就遥不可及的虚拟世界,再多一重欺骗的阴影.造数据.买排名--犹如原始时代的不成熟的网络时代,让人&quot;想说爱你不容易&quot;. 文/记者 冯秋瑜 图/新华社 电商被指数据造假 &quot;祝全体朋友们生日快乐!祝			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pnX4PZb.html" rel="bookmark">&OpenCurlyDoubleQuote;双十一&rdquo;狂欢 电商数据中心 你准备好了吗</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				随着&quot;双十一&quot;的临近,电商市场硝烟弥漫.天猫.京东.易迅.苏宁等http://www.aliyun.com/zixun/aggregation/7871.html&quot;&gt;电子商务平台摩拳擦掌.使出浑身解数,准备在&quot;双十一&quot;当天逐鹿厮杀.花样翻新的促销手段.O2O的全新零售模式.创意新颖的广告营销,在临近&quot;双十一&quot;的这几天轮番轰炸各大媒体平台,公众的关注焦点亦被牢牢锁定.面对令人垂涎欲滴的网购市场,人人都想分一杯羹,但电商平台真的准备好			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pkL7QEz.html" rel="bookmark">腾讯电商业务架构重组虽已完成仍面临流量变现难题</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				酝酿许久的腾讯架构重组终于浮出水面. 上周五,腾讯内部发文称,腾讯将从原有的业务系统制升级为事业群制,把现有业务重新划分成企业发展事业群(CDG).互动娱乐事业群(IEG).移动互联网事业群(MIG).网络媒体事业群(OMG).社交网络事业群(SNG),整合原有的研发和运营平台,成立新的技术工程事业群(TEG). 值得注意的是,电商业务单独拆分为腾讯电商控股公司(ECC),成为腾讯的全资子公司.在&lt;第一财经日报&gt;获得的一封内部邮件中,新任腾讯电商控股公司CEO吴宵光称,电商控股公司将在管理体系			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/4MYjjxp.html" rel="bookmark" class="title">oracle 字符串拆分，序列，插入数据</a>
					<div>
						问题描述 oracle 字符串拆分,序列,插入数据 insert into stud_sname1_417 (id,sname1) select seq_sname1_417,distinct sub ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ybjdA8p.html" rel="bookmark" class="title">网页细节设计&colon;网页中价格标示的设计方法</a>
					<div>
						文章简介:细节决定成败-价格的表现形式. 两周前逛浦东Apple Store,因为看上MacBook Air纠结着要攒几个月的钱而注目价格良久: 先感谢MH同学的职业敏感性--是否可以把印刷版式移植到 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/0zGmdoM.html" rel="bookmark" class="title">以何种模式处理彩色图片最好</a>
					<div>
						   在报纸的排版过程中,经常会遇到对彩色图片的处理,当打开某一个彩色图片时,它可能是RGB模式的,也可能是CMYK模式的.那么在使用photoshop时,是使用RGB模式,还是使用CMYK模式进行彩 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Lp5D0AM.html" rel="bookmark" class="title">快速提高网站权重方法二：外链王者</a>
					<div>
						大家好,我是虚子雨.在前面一篇文章&lt;快速提高网站权重方法一:内容捷径&gt;中,我就为大家介绍了网站权重在网站优化过程中的重要性,这里就不再赘言.在上一篇文章中,我谈到了内容是快速提高网站权重的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/jbEqN6b.html" rel="bookmark" class="title">Flash：MovieClipLoader事件处理秒差</a>
					<div>
						最近因为公司一个小案子上出的问题,研究了一下MovieClipLoader这东西的特性,  发觉到onLoadComplete的意义不等于onLoadInit.     也就是说,一般逻辑思考下,档案 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Xpmg7lb.html" rel="bookmark" class="title">网站是否被搜索引擎惩罚五种分析方法浅析</a>
					<div>
						每次百度更新的时候,总是几家欢喜几家愁,有的网站排名提升了,有的网站排名下降了,很多站长一旦发现自己网站排名下降了就会非常的担心自己的网站是不是被搜索引擎K站了,或者是被降权了,可是仅仅通过排名下降就 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/balq1Qz.html" rel="bookmark" class="title">开发IBM Lotus Domino Web 2&period;0客户机</a>
					<div>
						简介:使用 HTML 和 JavaScript 为 Lotus Domino 创建一个 Web 2.0 风格的瘦 Web 客户机.基于 以前有关 IBM Lotus Domino XML (DXL)  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MxWPVyb.html" rel="bookmark" class="title">Windows 7 下查看无线网络密码</a>
					<div>
						现在无线网络因其方便快捷的特点很受用户喜爱,其传输速度也较之前有了很大的提升.对于无线网络连接,Windows XP 无法直接查看到密码,但是 Windows 7 却可以.至于查看 Windows 7 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pP8kZlp.html" rel="bookmark" class="title">傲游浏览器如何清除浏览历史</a>
					<div>
						  首先打开傲游云浏览器右上角的三道杠图标 选择中间的清除浏览历史 在弹出的窗口按需要选择需要清理的内容,点击立即清除,就OK了					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/badBYQz.html" rel="bookmark" class="title">自动备份Photoshop CC设置文件到云端网盘该如何做</a>
					<div>
						  为了方便和节约时间我们可以家里和公司里的Photoshop设置同时同步,把Photoshop设置自动备份到网上,随时随地在多种电脑上使用相同的PS设置.那如何来操作呢?小编来教你一种方法,步骤如下 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bo7eL6b.html" rel="bookmark" class="title">新浪微博&OpenCurlyDoubleQuote;我的影响力&rdquo;能帮我分析什么？</a>
					<div>
						  用数据统计分析的方式,对您的围脖进行量化表达,让您轻松知道自己的影响力有多大. &quot;我的影响力&quot;数值由活跃度.传播力和覆盖度三者综合起来得出. 活跃度指您每天主动发博.转发.评论 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zwxZVWb.html" rel="bookmark" class="title">Mono For Android安装方法及破解</a>
					<div>
						本文能解决: Evaluation Version only deploys to emulators.Click to activete. 除了JDK必须自己下载,  其他东西我已经放到http:/ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPPE30p.html" rel="bookmark" class="title">c&plus;&plus;一些面试题目</a>
					<div>
						1.What is achieved by prefixing the 'static' keyword to a file-level function or file-level variable ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/boKkXgb.html" rel="bookmark" class="title">传亚马逊Android平板电脑将由三星代工</a>
					<div>
						北京时间4月21日上午消息,据美国科技网站Gdgt报道,亚马逊即将推出的Android平板电脑将由三星代工生产.此前Kindle等硬件产品都是由亚马逊旗下Lab126部门负责设计生产. 虽然有关亚马逊 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z44w4Jz.html" rel="bookmark" class="title">图文：微软大中华区副总裁曾良演讲</a>
					<div>
						图为:中国软件自助创新论坛暨报告发布会现场,微软大中华区副总裁兼公共事业部总经理曾良演讲. 新浪科技讯 6月17日消息,第九届中国国际软件和信息服务交易会(以下简称&quot;软交会&quot;)16 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bEY8Z3b.html" rel="bookmark" class="title">JavaScript中Array对象用法实例总结&lowbar;javascript技巧</a>
					<div>
						本文实例讲述了JavaScript中Array对象用法.分享给大家供大家参考,具体如下: Array数组对象有很多常用的方法和属性,现总结如下: 1. length属性,获取数组中元素的个数. 2.  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zV7rolb.html" rel="bookmark" class="title">网站被百度K后的处理方式</a>
					<div>
						一. 未改版被清0 如果你的站是没有改版,被百度清0了,一个收录页面也没有,这时你不要急,要和平常一样去更新网站.不要急于的放手了,有可能会起死回生的.当然,你还得多看看百度蜘蛛还在爬行你的网站没有, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MqWEgKz.html" rel="bookmark" class="title">如何制作一个防止多次刷新计数的图片计数器？&lowbar;编程10000问</a>
					<div>
						请问如何做一个专业的图片计数器? &lt;% countlong=8     ' 定义计数器位数. On Error Resume Next     ' 忽略所有的错误. count=server.m ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pk0RD5z.html" rel="bookmark" class="title">同方股份称三年内不分拆上市</a>
					<div>
						本报记者 刘勇 实习生 李根 北京报道 作为同方股份旗下众多子公司的一员,易程科技在2006年成立初期并不引人关注,直到近年来国内高铁进入大规模建设时期,易程科技接二连三地取得高铁 客服系统订单,这才 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z7QPNXM.html" rel="bookmark" class="title">无线充电技术日趋成熟 需求放量加速产业发展</a>
					<div>
						随着无线充电技术的成熟,支持无线充电的设备日益普及,未来无线充电需求也将快速增长.机构预计,无线充电市场规模有望从去年的20亿美元增长至2019年的110亿美元,未来发展空间巨大. 无线充电源于无线电 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mqgd5kz.html" rel="bookmark" class="title">永远不要低估&OpenCurlyQuote;春运&rsquo;这款产品的用户数</a>
					<div>
						摘要: 强烈抗议封锁GitHub.昨晚,李开复(微博)一条抗议知名技术网站GitHub被封的微博引起网友关注,三个小时内即被转发3.2万多次.李开复称,GitHub是全球最大的社交编程及代码托管网站, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zVdPqQM.html" rel="bookmark" class="title">《Java 开发从入门到精通》&mdash;&mdash; 2&period;4 Java的运行机制</a>
					<div>
						2.4 Java的运行机制 知识点讲解:光盘:视频PPT讲解(知识点)第2章Java的运行机制.mp4 Java语言是一种特殊的高级语言,它不但有解释性语言的特征,也有编译性语言的特征,我们需要先编译 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M0YGkJp.html" rel="bookmark" class="title">白宫升级IT设备 终于进入21世纪</a>
					<div>
						4月6日,外媒报道称,覆盖不全的WiFi信号.不时死机的电脑.上世纪的电话机,你可能想象不到,这里是白宫.不过,奥巴马计划对白宫的信息设备进行升级,让一年之后的继任者享受到最新的信息科技. 白宫西厢办 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zZmrR6p.html" rel="bookmark" class="title">再议高校教室监控 隐私与安全之间如何权衡</a>
					<div>
						2016年10月,一则中山大学拟在教室安装监控摄像头的消息曾引起一番热议.起因是中山大学印发了一份&lt;中山大学关于全面深化本科教育教学改革提高人才培养质量的若干意见&gt;,其中提出,拟&quot ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgW431M.html" rel="bookmark" class="title">javaEE hql多表查询求大师指导</a>
					<div>
						问题描述 现在想在Dao层写个查询方法可以使两张表内连,并且要他们的id相同并且Date和HoliDate要相同..请问该方法怎么写..我用的是List&lt;Attendence&gt;attend ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlWV1qb.html" rel="bookmark" class="title">毕业设计之学生个人信息修改&comma;望高手指点迷津&excl;</a>
					<div>
						问题描述 DimModiStringAsStringcmdOk.Enabled=NotcmdOk.EnabledcmdClose.Enabled=NotcmdClose.EnabledcmdReg.E ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgWdm8M.html" rel="bookmark" class="title">Qt之QFileSystemWatcher</a>
					<div>
						简述 QFileSystemWatcher类用于提供监视文件和目录修改的接口. QFileSystemWatcher通过监控指定路径的列表,监视文件系统中文件和目录的变更. 调用addPath()函数 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zw58mdM.html" rel="bookmark" class="title">上传图片的问题？？</a>
					<div>
						问题描述 在JavaEE中用ssh框架怎样解决上传图片的呢? 解决方案 解决方案二:不知到你用的是Struts1还是2给你一个1的列子jsp页面代码&lt;%@pagecontentType=&quo ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvqPe1b.html" rel="bookmark" class="title">全民膜拜！&OpenCurlyDoubleQuote;航母Style&rdquo;在网络爆红</a>
					<div>
						全民膜拜!&quot;航母Style&quot;在网络爆红 (1/25) 全屏观看 &quot; &quot; 可实现快速翻页 解密真实的外星人真相 屌丝最新标准,你中几枪 日本人泡2506.html ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M0O73nb.html" rel="bookmark" class="title">checkbox问题</a>
					<div>
						问题描述 如何利用cookie实现checkbox翻页保存选项,我使用的是JSP的,谁能给个例子,方便我理解下,谢谢,给个具体的例子就行. 解决方案 解决方案二:checkbox翻页保存选项是啥东西? ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.093 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
